/*
  LOG_PARGRUPOFISC_TPFATURFIS responsvel por gravar as informaes
  na tabela LOGOPERA a partir dos registros que forem includos,
  excludos e alterados na tabela TPFATURFIS na tela de
  "Parmetros de Grupo Fiscal - Tipo de Gesto Fiscal"
  ou na tela de "Tipo de Gesto Fiscal"
  Criao: 02/05/2012
  Lucas Primo
*/

CREATE OR REPLACE TRIGGER LOG_PARGRUPOFISC_TPFATURFIS
AFTER DELETE OR INSERT OR UPDATE
ON TPFATURFIS FOR EACH ROW

DECLARE
  V_CDFILLOGOPER VARCHAR2(4);
  V_USUARIO	 VARCHAR2(40);
  V_TIPO	 VARCHAR2(1);
  V_ITPESQ	 VARCHAR2(40);
  V_DESC	 VARCHAR2(300);
  V_DTOPER	 DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO         := '0';
   V_DESC         := '';
   V_CDFILLOGOPER := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN

      V_DESC := V_DESC || ' Tela= '    || 'Tipo de Gesto Fiscal';
      IF :OLD.CDTPFATURFIS IS NOT NULL THEN
         V_DESC := V_DESC || ' Codigo= ' || :OLD.CDTPFATURFIS;
      END IF;

      IF :OLD.NMTPFATURFIS IS NOT NULL THEN
         V_DESC := V_DESC || ' Desc= ' || :OLD.NMTPFATURFIS;
      END IF;

      IF :OLD.CDGRUPOFISC IS NOT NULL THEN
         V_DESC := V_DESC || ' Grupo= ' || :OLD.CDGRUPOFISC;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDTPFATURFIS;
   ELSE
      IF UPDATING THEN

         V_DESC := V_DESC || ' Aba= '    || 'Tipo de Gesto Fiscal';
         V_DESC := V_DESC || ' Codigo= ' || :NEW.CDTPFATURFIS;
         V_DESC := V_DESC || ' Desc= '   || :NEW.NMTPFATURFIS;

         IF NVL(:OLD.CDGRUPOFISC, '!') <> NVL(:NEW.CDGRUPOFISC, '!') THEN
            V_DESC := V_DESC || ' Grupo= ' || :NEW.CDGRUPOFISC;
         END IF;

         V_TIPO         := '2';
         V_ITPESQ       := :OLD.CDTPFATURFIS;
      ELSE
         IF INSERTING THEN
         
            V_DESC := V_DESC || ' Tela= '    || 'Tipo de Gesto Fiscal';
            V_DESC := V_DESC || ' Codigo= ' || :NEW.CDTPFATURFIS;
            V_DESC := V_DESC || ' Desc= '   || :NEW.NMTPFATURFIS;
            V_DESC := V_DESC || ' Grupo= '  || :NEW.CDGRUPOFISC;

            V_TIPO         := '1';
            V_ITPESQ       := :NEW.CDTPFATURFIS;
         END IF;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN

      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,  CDPESQITEM, IDTIPOOPER,  DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PARGRUPOFISC',   V_DTOPER,       V_USUARIO,   V_ITPESQ, V_TIPO, SUBSTR(V_DESC,1,300),
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PARGRUPOFISC_TPFATURFIS','5.42.000'); END;
/
